//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ActnList.hpp>
#include <ImgList.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <StdActns.hpp>
#include <Buttons.hpp>

#include "Settings.h"
#include "Callback.h"
#include <vector>

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE-managed Components
	TMainMenu *MainMenu;
	TMenuItem *miFile;
	TMenuItem *miSettings;
	TMenuItem *miHelp;
	TMenuItem *miAbout;
	TMenuItem *miCommonSettings;
	TActionList *ActionList;
	TImageList *imglistActions;
	TAction *actShowAbout;
	TAction *actShowSettings;
	TStatusBar *StatusBar;
	TMenuItem *miView;
	TMenuItem *miViewLog;
	TAction *actShowLog;
	TTimer *tmrStartup;
	TTimer *tmrCallbackPoll;
	TMenuItem *miExit;
	TFileExit *FileExit1;
	TPanel *pnlTop;
	TGroupBox *grboxAccounts;
	TListView *lvAccounts;
	TGroupBox *grboxMakeCall;
	TSpeedButton *btnBackspace;
	TComboBox *cbCallURI;
	TButton *btnMakeCall;
	TPanel *pnlMain;
	TGroupBox *grboxCallControl;
	TButton *btnHangup;
	TGroupBox *grboxCalls;
	TListView *lvCalls;
	TButton *btnAnswer;
	TButton *btnCallDial1;
	TButton *btnCallDial2;
	TButton *btnCallDial3;
	TButton *btnCallDial4;
	TButton *btnCallDial5;
	TButton *btnCallDial6;
	TButton *btnCallDial7;
	TButton *btnCallDial8;
	TButton *btnCallDial9;
	TButton *btnCallDialStar;
	TButton *btnCallDial0;
	TButton *btnCallDialHash;
	TButton *btnDial1;
	TButton *btnDial2;
	TButton *btnDial3;
	TButton *btnDial4;
	TButton *btnDial5;
	TButton *btnDial6;
	TButton *btnDial7;
	TButton *btnDial8;
	TButton *btnDial9;
	TButton *btnDialStar;
	TButton *btnDial0;
	TButton *btnDialHash;
	TPopupMenu *popupCalls;
	TMenuItem *miClearFinishedCalls;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall actShowAboutExecute(TObject *Sender);
	void __fastcall actShowSettingsExecute(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall actShowLogExecute(TObject *Sender);
	void __fastcall tmrStartupTimer(TObject *Sender);
	void __fastcall btnMakeCallClick(TObject *Sender);
	void __fastcall btnHangupClick(TObject *Sender);
	void __fastcall tmrCallbackPollTimer(TObject *Sender);
	void __fastcall btnDialClick(TObject *Sender);
	void __fastcall btnBackspaceClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall lvAccountsData(TObject *Sender, TListItem *Item);
	void __fastcall lvAccountsChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
	void __fastcall lvAccountsMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall lvCallsData(TObject *Sender, TListItem *Item);
	void __fastcall btnAnswerClick(TObject *Sender);
	void __fastcall btnCallDialClick(TObject *Sender);
	void __fastcall miClearFinishedCallsClick(TObject *Sender);
private:	// User declarations
	void UpdateCallHistory(void);
	AnsiString CleanUri(AnsiString uri);
	std::vector<Callback::reg_state_e> reg_state;
	TListItem *prevSelectedAcc;
	char TagToDigit(int tag);

public:		// User declarations
	__fastcall TfrmMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
