//---------------------------------------------------------------------------

#ifndef UaCallsH
#define UaCallsH
//---------------------------------------------------------------------------

#include "Callback.h"
#include <vector>
#include <map>
#include <System.hpp>

class UaCalls
{
public:
	UaCalls(void);
	enum Dir {
		INCOMING = 0,
		OUTGOING
	};	
	struct CallData
	{
		int callId;
		int accId;
		enum Dir dir;
		AnsiString uri;
		enum Callback::ua_state_e state;
		CallData(void) {
			callId = -1;
			accId = -1;
			dir = INCOMING;
		}
	};
	std::vector<struct CallData> calls;
	int AllocCallId(void);
	CallData* AllocCall(int callId, int accId, AnsiString uri, enum Dir dir, Callback::ua_state_e state);
	CallData* FindCall(int callId);
	int SetState(int callId, Callback::ua_state_e state);
	void ReleaseCall(int callId);
	void ReleaseFinished(void);
};

#endif
